--
--
-- DMEMORY module (provides the data memory for the SPIM computer)
library synth;
use synth.stdsynth.all;

entity dmemory is

 
   port(rd_bus : out vlbit_1D(7 downto 0);
	ra_bus : in vlbit_1D(7 downto 0);
	wd_bus : in vlbit_1D(7 downto 0);
	wa_bus : in vlbit_1D(7 downto 0);
	MemRead, Memwrite, MemtoReg : in vlbit;
		phi1,phi2,reset: in vlbit);

end dmemory;

--
-- DMEMORY architecture
--

architecture behaviour of dmemory is
	  
	  signal mem0,mem1,mem2,mem3,mem4,mem5,mem6,mem7 : vlbit_1d(7 downto 0);
	  signal mux : vlbit_1d(7 downto 0);
	  signal mem0write, mem1write : vlbit;


begin
-- Read Data Memory
with ra_bus(2 downto 0) select
mux <= mem0 WHEN "000",
	   mem1 WHEN "001",
	   mem2 WHEN "010",
	   mem3 WHEN "011",
	   mem4 WHEN "100",
	   mem5 WHEN "101",
	   mem6 WHEN "110",
	   mem7 WHEN "111";

-- Mux to skip data memory for Rformat instructions
rd_bus <= ra_bus(7 downto 0) WHEN (MemtoReg='0') ELSE mux WHEN (MemRead='1')
		ELSE B"XXXXXXXX";

-- Write to data memory?
-- The following code sets an initial value and replaces the next line
--dff_v(wd_bus,phi2 AND Memwrite AND (wa_bus(2 downto 0)="000"),mem0);
mem0write <= boo2vlb(phi2='1') AND Memwrite AND (wa_bus(2 downto 0)="000");
mem1write <= boo2vlb(phi2='1') AND Memwrite AND (wa_bus(2 downto 0)="001");
process
begin   
wait until (prising(mem0write) OR (reset = '1'));
   if (reset = '1') then
	mem0 <= X"55";
   else
	mem0 <=wd_bus;
   end if;
end process;

--dff_v(wd_bus,phi2 AND Memwrite AND (wa_bus(2 downto 0)="001"),mem1);
process
begin   
wait until (prising(mem1write) OR (reset = '1'));
   if (reset = '1') then
	mem1 <= X"AA";
   else
	mem1 <=wd_bus;
   end if;
end process;
dff_v(wd_bus,phi2 AND Memwrite AND (wa_bus(2 downto 0)="010"),mem2);
dff_v(wd_bus,phi2 AND Memwrite AND (wa_bus(2 downto 0)="011"),mem3);
dff_v(wd_bus,phi2 AND Memwrite AND (wa_bus(2 downto 0)="100"),mem4);
dff_v(wd_bus,phi2 AND Memwrite AND (wa_bus(2 downto 0)="101"),mem5);
dff_v(wd_bus,phi2 AND Memwrite AND (wa_bus(2 downto 0)="110"),mem6);
dff_v(wd_bus,phi2 AND Memwrite AND (wa_bus(2 downto 0)="111"),mem7);
end behaviour;

